/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
import { Directive, HostBinding, Input } from '@angular/core';
import { DomSanitizer } from '@angular/platform-browser';
import { buildURI } from './util';
export class CsvDirective {
    /**
     * @param {?} sanitizer
     */
    constructor(sanitizer) {
        this.sanitizer = sanitizer;
        /**
         * the body of the csv
         */
        this.data = [];
        /**
         * Set the seperator between values
         */
        this.delimiter = ',';
        /**
         * adds a Byte order mark to setup the csv as UTF-8
         */
        this.uFEFF = true;
        /**
         * filename
         */
        this.download = 'data.csv';
        this.target = '_blank';
    }
    /**
     * Set the filename of the csv. Default is `data.csv`
     * @param {?} a
     * @return {?}
     */
    set filename(a) {
        this.download = a;
    }
    /**
     * @return {?}
     */
    ngOnChanges() {
        this.href = this.sanitizer.bypassSecurityTrustResourceUrl(buildURI(this.data, this.uFEFF, this.headers, this.delimiter));
    }
}
CsvDirective.decorators = [
    { type: Directive, args: [{ selector: 'a[csvLink]' },] },
];
/** @nocollapse */
CsvDirective.ctorParameters = () => [
    { type: DomSanitizer, },
];
CsvDirective.propDecorators = {
    "data": [{ type: Input },],
    "headers": [{ type: Input },],
    "delimiter": [{ type: Input },],
    "filename": [{ type: Input },],
    "uFEFF": [{ type: Input },],
    "href": [{ type: HostBinding },],
    "download": [{ type: HostBinding },],
    "target": [{ type: Input }, { type: HostBinding },],
};
function CsvDirective_tsickle_Closure_declarations() {
    /** @type {!Array<{type: !Function, args: (undefined|!Array<?>)}>} */
    CsvDirective.decorators;
    /**
     * @nocollapse
     * @type {function(): !Array<(null|{type: ?, decorators: (undefined|!Array<{type: !Function, args: (undefined|!Array<?>)}>)})>}
     */
    CsvDirective.ctorParameters;
    /** @type {!Object<string,!Array<{type: !Function, args: (undefined|!Array<?>)}>>} */
    CsvDirective.propDecorators;
    /**
     * the body of the csv
     * @type {?}
     */
    CsvDirective.prototype.data;
    /**
     * Set the first line of the csv
     * @type {?}
     */
    CsvDirective.prototype.headers;
    /**
     * Set the seperator between values
     * @type {?}
     */
    CsvDirective.prototype.delimiter;
    /**
     * adds a Byte order mark to setup the csv as UTF-8
     * @type {?}
     */
    CsvDirective.prototype.uFEFF;
    /** @type {?} */
    CsvDirective.prototype.href;
    /**
     * filename
     * @type {?}
     */
    CsvDirective.prototype.download;
    /** @type {?} */
    CsvDirective.prototype.target;
    /** @type {?} */
    CsvDirective.prototype.sanitizer;
}
//# sourceMappingURL=csv.directive.js.map
