import * as tslib_1 from "tslib";
/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes} checked by tsc
 */
/**
 * @record
 */
export function HeaderObj() { }
function HeaderObj_tsickle_Closure_declarations() {
    /** @type {?} */
    HeaderObj.prototype.label;
    /** @type {?} */
    HeaderObj.prototype.key;
}
export var /** @type {?} */ isJsons = function (array) { return Array.isArray(array) &&
    array.every(function (row) { return typeof row === 'object' && !(row instanceof Array); }); };
export var /** @type {?} */ isArrays = function (array) { return Array.isArray(array) && array.every(function (row) { return Array.isArray(row); }); };
/**
 * @param {?} array
 * @return {?}
 */
export function jsonsHeaders(array) {
    return Array.from(new Set(array.map(function (item) { return Object.keys(item); }).reduce(function (a, b) { return tslib_1.__spread(a, b); }, [])));
}
/**
 * @param {?} jsons
 * @param {?=} headers
 * @return {?}
 */
export function jsons2arrays(jsons, headers) {
    headers = headers || jsonsHeaders(jsons);
    // allow headers to have custom labels, defaulting to having the header data key be the label
    var /** @type {?} */ headerLabels = (headers);
    var /** @type {?} */ headerKeys = (headers);
    if (isJsons(headers)) {
        headerLabels = ((headers)).map(function (header) { return header.label; });
        headerKeys = ((headers)).map(function (header) { return header.key; });
    }
    var /** @type {?} */ data = jsons.map(function (object) { return headerKeys.map(function (header) { return (header in object ? object[header] : ''); }); });
    return tslib_1.__spread([headerLabels], data);
}
export var /** @type {?} */ elementOrEmpty = function (element) { return element || element === 0 ? element : ''; };
/**
 * @param {?} data
 * @param {?=} delimiter
 * @return {?}
 */
export function joiner(data, delimiter) {
    if (delimiter === void 0) { delimiter = ','; }
    return data
        .map(function (row, index) { return row.map(function (element) { return '"' + elementOrEmpty(element) + '"'; }).join(delimiter); })
        .join("\n");
}
/**
 * @param {?} data
 * @param {?=} headers
 * @param {?=} delimiter
 * @return {?}
 */
export function arrays2csv(data, headers, delimiter) {
    return joiner(headers ? tslib_1.__spread([headers], data) : data, delimiter);
}
/**
 * @param {?} data
 * @param {?=} headers
 * @param {?=} delimiter
 * @return {?}
 */
export function jsons2csv(data, headers, delimiter) {
    return joiner(jsons2arrays(data, headers), delimiter);
}
/**
 * @param {?} data
 * @param {?=} headers
 * @param {?=} delimiter
 * @return {?}
 */
export function string2csv(data, headers, delimiter) {
    return headers ? headers.join(delimiter) + "\n" + data : data;
}
/**
 * @param {?} data
 * @param {?=} headers
 * @param {?=} delimiter
 * @return {?}
 */
export function toCSV(data, headers, delimiter) {
    if (isJsons(/** @type {?} */ (data))) {
        return jsons2csv(/** @type {?} */ (data), headers, delimiter);
    }
    if (isArrays(/** @type {?} */ (data))) {
        return arrays2csv(/** @type {?} */ (data), headers, delimiter);
    }
    if (typeof data === 'string') {
        return string2csv(data, /** @type {?} */ (headers), delimiter);
    }
    throw new TypeError("Data should be a \"String\", \"Array of arrays\" OR \"Array of objects\" ");
}
/**
 * @param {?} data
 * @param {?=} uFEFF
 * @param {?=} headers
 * @param {?=} delimiter
 * @return {?}
 */
export function buildURI(data, uFEFF, headers, delimiter) {
    if (uFEFF === void 0) { uFEFF = true; }
    var /** @type {?} */ csv = toCSV(data, headers, delimiter);
    var /** @type {?} */ blob = new Blob([uFEFF ? '\uFEFF' : '', csv], { type: 'text/csv' });
    return URL.createObjectURL(blob);
}
//# sourceMappingURL=util.js.map
